using System;
using System.Data;
using System.Drawing;
using System.Data.OleDb;
using System.Collections;

using Syncfusion.Windows.Forms.Diagram;

namespace SankeyTest
{
	/// <summary>
	/// Ari_DrawSankey ժҪ˵
	/// </summary>
	public class Ari_DrawSankey
	{
		public Syncfusion.Windows.Forms.Diagram.Controls.Diagram Diagram;
		public string currentpath;
		public DataTable dtValue;
		public DataSet dsConfig;
		private int iTableIndex;

		public Ari_DrawSankey()
		{
			//
			// TODO: ڴ˴ӹ캯߼
			//
		}

		public Ari_DrawSankey(Syncfusion.Windows.Forms.Diagram.Controls.Diagram Diagram, string currentpath)
		{
			//
			// TODO: ڴ˴ӹ캯߼
			//
			this.Diagram = Diagram;
			this.currentpath = currentpath;
			this.dtValue = new DataTable("Value");
			this.dsConfig = new DataSet("SankeyConfig");
			this.iTableIndex = -1;
		}

		// Reads the flow node data from the oracle database and creates the diagram organization tree.
		public void InitializeDiagramFromDatabase()
		{
			// Clear the diagram model of all existing nodes
			if(this.Diagram.Model.ChildCount > 0)
				this.Diagram.Model.Clear();

			// Read data from the oracle dataasource and populate a Hashtable using the flow node ID as the key
			Hashtable htflownodes = this.ReadFlowNodeDataFromDatabase();

			// Create a manager-flownode nested list with top-level flownodes forming the root nodes
			ArrayList sortedlist = this.GetSortedFlowNodesList(htflownodes);

			foreach(Ari_FlowNode node in sortedlist)
			{
				this.iTableIndex++;
				DataTable dtConfigSchema = new DataTable();
				dtConfigSchema.TableName = node.FlowNodeName;
				dtConfigSchema.Columns.Add("ProcessName");
				dtConfigSchema.Columns.Add("InputName");
				dtConfigSchema.Columns.Add("OutputName");
				DataRow dr = dtConfigSchema.NewRow();
				dr["ProcessName"] = node.FlowNodeName;
				dtConfigSchema.Rows.Add(dr);
				dsConfig.Tables.Add(dtConfigSchema);

				this.IterUpdateSubFlowNodeCount(node);
			}

			// Create diagram symbol nodes for each flow node and initialize the diagram
			this.CreateOrgDiagramFromList(sortedlist);

			htflownodes.Clear();
		}

		// Connect to the Access database and query the flow node information using an ADO.NET data reader
		private Hashtable ReadFlowNodeDataFromDatabase()
		{
			Hashtable htflownodes = new Hashtable();

			// Connection string for the Oracle database
			string datasrcpath = currentpath.Substring(0,currentpath.IndexOf("bin")) + "data\\FlowNodes3.mdb";
			string connectionstring = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" + datasrcpath + ";";
			OleDbConnection orgdbconnection = new OleDbConnection(connectionstring);
			// Query to select all records from the Oracle database
			string orgdbselectquery = "SELECT ID, Name, ManagerID, Value, IsInputNode FROM FlowNodes";
			OleDbCommand orgdbcommand = new OleDbCommand(orgdbselectquery, orgdbconnection);
			// Create a connection to the datasource
			orgdbconnection.Open();
			// Execute the query command to build the data reader			
			OleDbDataReader orgdbreader = orgdbcommand.ExecuteReader();
			// Extract flow node data from the reader
			while(orgdbreader.Read()) 
			{				
				object[] flownodedata = new object[5];
				int count = orgdbreader.GetValues(flownodedata);				

				// Create an flow node instance to represent each flow node
				Ari_FlowNode flownode = new Ari_FlowNode();
				flownode.FlowNodeID = flownodedata[0].ToString();
				flownode.FlowNodeName = (string)flownodedata[1];
				if(count == 5)
				{
					flownode.ManagerID = flownodedata[2].ToString();
					flownode.FlowNodeValue = flownodedata[3].ToString();
				}
				flownode.FlowNodeIsInputNode = Convert.ToBoolean(flownodedata[4]);
				htflownodes.Add(flownode.FlowNodeID, flownode);		
			}
			// Close the reader
			orgdbreader.Close();
			// Close the connection
			orgdbcommand.Connection.Close();
			
			return htflownodes;
		}

		// Rearrange the flownodes collection as a manager-subflownode nested tree
		private ArrayList GetSortedFlowNodesList(Hashtable htflownodes)
		{
			ArrayList sortedlist = new ArrayList();
			foreach(Ari_FlowNode flownode in htflownodes.Values)
			{
				if(flownode.ManagerID == String.Empty)
				{
					// FlowNodes without a ManagerID are top-level nodes in the org tree
					sortedlist.Add(flownode);
				}
				else
				{
					// Find the flownode instance associated with the managerID and add this object as 
					// a subflownode of the manager node.
					Ari_FlowNode manager = (Ari_FlowNode)htflownodes[flownode.ManagerID];
					if(manager != null)
						manager.SubFlowNodes.Add(flownode);											
				}
			}

			return sortedlist;
		}

		private void IterUpdateSubFlowNodeCount(Ari_FlowNode flownode)
		{
			flownode.RecSubFlowNodeCount = flownode.SubFlowNodes.Count;
			flownode.LevelCount += 1;
			foreach(Ari_FlowNode subflownode in flownode.SubFlowNodes)
			{
				DataRow dr = this.dsConfig.Tables[this.iTableIndex].NewRow();
				if (subflownode.FlowNodeIsInputNode)
					dr["InputName"] = subflownode.FlowNodeName;
				else
					dr["OutputName"] = subflownode.FlowNodeName;
				this.dsConfig.Tables[this.iTableIndex].Rows.Add(dr);
				this.dtValue.Columns.Add(subflownode.FlowNodeName);

				subflownode.LevelCount += flownode.LevelCount;
				this.IterUpdateSubFlowNodeCount(subflownode);				
				flownode.RecSubFlowNodeCount += subflownode.RecSubFlowNodeCount;
			}
		}
		
		public int CalNodeNumber(bool bIsInputNode, Ari_FlowNode flownode, ArrayList alList)
		{
			int iNodeNumber = 0;
			if (bIsInputNode)
			{
				foreach(Ari_FlowNode fnode in alList)
				{
					if (fnode.ManagerID == flownode.FlowNodeID && fnode.FlowNodeIsInputNode)
						iNodeNumber++;
				}
			}
			else
			{
				foreach(Ari_FlowNode fnode in alList)
				{
					if (fnode.ManagerID == flownode.FlowNodeID && !fnode.FlowNodeIsInputNode)
						iNodeNumber++;
				}
			}
			return iNodeNumber;
		}

		private void CalLevelNumber(Ari_FlowNode flownode, ref int nLevelCount)
		{
			if (nLevelCount < flownode.LevelCount)
				nLevelCount = flownode.LevelCount;
			foreach(Ari_FlowNode subflownode in flownode.SubFlowNodes)
			{
				if (subflownode.FlowNodeIsInputNode)
					this.CalLevelNumber(subflownode, ref nLevelCount);
			}
		}

		private void CreateOrgDiagramFromList(ArrayList alflownodes)
		{				
			float dX = 50;
			foreach(Ari_FlowNode flownode in alflownodes)
			{				
				// Create a FlowNodeSymbol for each flownode in the organization and add the membersymbol to 
				// the diagram.			
				int nLevelCount = 0;
				this.CalLevelNumber(flownode, ref nLevelCount);

				Ari_ProcessSymbol processSymbol = new Ari_ProcessSymbol(CalNodeNumber(true, flownode, flownode.SubFlowNodes),
					CalNodeNumber(false, flownode, flownode.SubFlowNodes));
				processSymbol.FlowNodeID = flownode.FlowNodeID;
				processSymbol.FlowNodeName = flownode.FlowNodeName;

				processSymbol.X = dX;
				processSymbol.Y = (nLevelCount-1) * 170 + 500;

				dX = processSymbol.X + processSymbol.Width + 500;

				// Merely add the various symbols to the Diagram. Positioning the various nodes within the 
				// diagram will be the responsibility of the OrgChartManager LayoutManager. Nodes will be 
				// positioned based on their level in the organization hierarchy.
				this.Diagram.Model.AppendChild(processSymbol);

//				float fLeft = 50;
//				this.IterCreateFlowNodeSymbol(flownode, processSymbol, nLevelCount, fLeft);
				this.IterCreateFlowNodeSymbol(flownode, processSymbol, nLevelCount);
			}
			this.Diagram.Model.EndUpdate(false);	// ReEnable the Model redraw
		}

		// Iterative sub-flownode symbol node creation
		private void IterCreateFlowNodeSymbol(Ari_FlowNode flownode, Ari_ProcessSymbol flownodesymbol, int nLevelCount, float fLeft)
		{
			int iInputNumber = 0, iOutputNumber = 0;
			int iInputNum = CalNodeNumber(true, flownode, flownode.SubFlowNodes);
			int iOutputNum = CalNodeNumber(false, flownode, flownode.SubFlowNodes);
			foreach(Ari_FlowNode subflownode in flownode.SubFlowNodes)
			{
				// Create a FlowNodeSymbol for each of the sub-flownodes of the particular flownode
				Ari_FlowNodeSymbol subflownodesymbol = new Ari_FlowNodeSymbol(subflownode.SubFlowNodes.Count, subflownode.FlowNodeIsInputNode);
				subflownodesymbol.FlowNodeID = subflownode.FlowNodeID;
				subflownodesymbol.FlowNodeName = subflownode.FlowNodeName;
				subflownodesymbol.ManagerID = subflownode.ManagerID;
				subflownodesymbol.FlowNodeValue = subflownode.FlowNodeValue;
				subflownodesymbol.FlowNodeIsInputNode = subflownode.FlowNodeIsInputNode;
				subflownodesymbol.RecSubFlowNodeCount = subflownode.RecSubFlowNodeCount;

				// Create the CustomOrthogonalLink to connect the employee symbol with it's subemployee symbol.
				// Specifying the South and North compass headings for the link end point headings ensures that 
				// links connecting nodes that are in the same level will have identical line segments.

				MyLink ortholink = new MyLink(subflownodesymbol.CenterPort.Location, CompassHeading.South, 
					subflownodesymbol.CenterPort.Location, CompassHeading.North);
				LinkCmd linkCmd = new LinkCmd();
				ortholink.EndPoints.FirstEndPointDecorator = new EndPointDecorator(EndPointVisuals.Diamond);
				ortholink.EndPoints.LastEndPointDecorator = new EndPointDecorator(EndPointVisuals.ClosedArrow);
				linkCmd.Link = ortholink;
				//linkCmd.SourcePort = node1.CenterPort;
				//linkCmd.TargetPort = node9.topport1;
				

//				LinkCmd linkcommand = new LinkCmd();
//				Link link = new Link(Link.Shapes.OrthogonalLine);
//				link.EndPoints.LastEndPointDecorator = new EndPointDecorator(EndPointVisuals.ClosedArrow);
//				link.EndPoints.LastEndPointDecorator.FillStyle.Color = Color.Black;
//				link.Labels.Add(new Syncfusion.Windows.Forms.Diagram.LinkLabel(link, iInputNumber.ToString()));
//
//				link.LineStyle.LineWidth=1;
//				link.Labels[0].BackgroundStyle.Color=Color.White;
//				link.Labels[0].FontStyle.Bold = true;
//				linkcommand.Link = link;			

				// Set up the source and target ports for the link
				if (subflownodesymbol.FlowNodeIsInputNode)
				{
//					if (iInputNum % 2 == 0)
//					{
//						if (iInputNumber < iInputNum/2)
//						{
//							subflownodesymbol.X = flownodesymbol.X + flownodesymbol.Width/2 - 250*(iInputNum/2-iInputNumber) + 25;
//							linkcommand.TargetPort = flownodesymbol.left_topports[iInputNumber];
//						}
//						else
//						{
//							subflownodesymbol.X = flownodesymbol.X + flownodesymbol.Width/2 + 250*(iInputNumber-iInputNum/2) + 25;
//							linkcommand.TargetPort = flownodesymbol.right_topports[iInputNumber-iInputNum/2];
//						}
//						linkcommand.SourcePort =subflownodesymbol.bottomport;
//					}
//					else
//					{
//						if (iInputNumber < (iInputNum-1)/2)
//						{
//							subflownodesymbol.X = flownodesymbol.X + flownodesymbol.Width/2 - 250*((iInputNum-1)/2-iInputNumber) - subflownodesymbol.Width/2;
//							linkcommand.TargetPort = flownodesymbol.left_topports[iInputNumber];
//						}
//						else if (iInputNumber == (iInputNum-1)/2)
//						{
//							subflownodesymbol.X = flownodesymbol.X + flownodesymbol.Width/2 - subflownodesymbol.Width/2;
//							linkcommand.TargetPort = flownodesymbol.topport;
//						}
//						else
//						{
//							subflownodesymbol.X = flownodesymbol.X + flownodesymbol.Width/2 + 250*(iInputNumber-(iInputNum-1)/2) - subflownodesymbol.Width/2;
//							linkcommand.TargetPort = flownodesymbol.right_topports[iInputNumber-1-(iInputNum-1)/2];
//						}
//						linkcommand.SourcePort =subflownodesymbol.bottomport;
//					}



					subflownodesymbol.Y = 600 + flownodesymbol.Height + (nLevelCount-1+subflownode.LevelCount-2) * 170;//(nLevelCount-subflownode.LevelCount) * 170 + 500;
					iInputNumber++;
				}
				else
				{
//					if (iOutputNum % 2 == 0)
//					{
//						if (iOutputNumber < iOutputNum/2)
//						{
//							subflownodesymbol.X = flownodesymbol.X + flownodesymbol.Width/2 - 250*(iOutputNum/2-iOutputNumber) + 25;
//							linkcommand.SourcePort = flownodesymbol.left_bottomports[iOutputNumber];
//						}
//						else
//						{
//							subflownodesymbol.X = flownodesymbol.X + flownodesymbol.Width/2 + 250*(iOutputNumber-iOutputNum/2) + 25;
//							linkcommand.SourcePort = flownodesymbol.right_bottomports[iOutputNumber-iOutputNum/2];
//						}
//						linkcommand.TargetPort =subflownodesymbol.topport;
//					}
//					else
//					{
//						if (iOutputNumber < (iOutputNum-1)/2)
//						{
//							subflownodesymbol.X = flownodesymbol.X + flownodesymbol.Width/2 - 250*((iOutputNum-1)/2-iOutputNumber) - subflownodesymbol.Width/2;
//							linkcommand.SourcePort = flownodesymbol.left_bottomports[iOutputNumber];
//						}
//						else if (iOutputNumber == (iOutputNum-1)/2)
//						{
//							subflownodesymbol.X = flownodesymbol.X + flownodesymbol.Width/2 - subflownodesymbol.Width/2;
//							linkcommand.SourcePort = flownodesymbol.bottomport;
//						}
//						else
//						{
//							subflownodesymbol.X = flownodesymbol.X + flownodesymbol.Width/2 + 250*(iOutputNumber-(iOutputNum-1)/2) - subflownodesymbol.Width/2;
//							linkcommand.SourcePort = flownodesymbol.right_bottomports[iOutputNumber-1-(iOutputNum-1)/2];
//						}
//						linkcommand.TargetPort =subflownodesymbol.topport;
//					}



					subflownodesymbol.Y = 600 + flownodesymbol.Height + (nLevelCount-1+subflownode.LevelCount-2) * 170;
					iOutputNumber++;
				}
				float fRight = fLeft;
				if (subflownodesymbol.RecSubFlowNodeCount == 0)
					fRight += 250;
				else
					fRight += subflownodesymbol.RecSubFlowNodeCount * 250;
				subflownodesymbol.X = (fLeft + fRight)/2 - subflownodesymbol.Width/2;
				fLeft = fRight;
				
				this.Diagram.Model.AppendChild(subflownodesymbol);			
				// Execute the command to connect the two symbols
				//this.Diagram.Controller.ExecuteCommand(linkCmd);
				this.Diagram.Controller.ExecuteCommand(linkCmd);

//				this.IterCreateFlowNodeSymbol(subflownode, subflownodesymbol, nLevelCount);
			}
		}				

		private bool CheckIsHaveFlowNode(Ari_FlowNodeSymbol subflownodesymbol)
		{
			bool bReturn = false;

			foreach(INode curNode in this.Diagram.Model.Nodes)
			{
				if (curNode.FullName.IndexOf("Ari_FlowNodeSymbol")>0)
				{
					Ari_FlowNodeSymbol flownodesymbol = curNode as Ari_FlowNodeSymbol;
					if ((Math.Abs(flownodesymbol.X - subflownodesymbol.X) <= subflownodesymbol.Width && flownodesymbol.Y == subflownodesymbol.Y)
						|| (Math.Abs(flownodesymbol.Y - subflownodesymbol.Y) <= subflownodesymbol.Height) && flownodesymbol.X == subflownodesymbol.X)
						bReturn = true;
				}
			}

			return bReturn;
		}

		private void CalFlowNodeLevel(Ari_FlowNode flownode)
		{
			foreach(Ari_FlowNode subflownode in flownode.SubFlowNodes)
			{
				if (subflownode.FlowNodeIsInputNode)
					subflownode.LevelCount += 1;
				else
					subflownode.LevelCount += 1;
			}
		}

		// Iterative sub-flownode symbol node creation
		private void IterCreateFlowNodeSymbol(Ari_FlowNode flownode, Ari_FlowNodeSymbol flownodesymbol, int nLevelCount)
		{
			int iInputNumber = 0, iOutputNumber = 0;
			int iInputNum = 0, iOutputNum = 0;
			if (flownode.FlowNodeIsInputNode)
				iInputNum = flownode.SubFlowNodes.Count;
			else
				iOutputNum = flownode.SubFlowNodes.Count;
			foreach(Ari_FlowNode subflownode in flownode.SubFlowNodes)
			{
				// Create a FlowNodeSymbol for each of the sub-flownodes of the particular flownode
				Ari_FlowNodeSymbol subflownodesymbol = new Ari_FlowNodeSymbol(subflownode.SubFlowNodes.Count, subflownode.FlowNodeIsInputNode);
				subflownodesymbol.FlowNodeID = subflownode.FlowNodeID;
				subflownodesymbol.FlowNodeName = subflownode.FlowNodeName;
				subflownodesymbol.ManagerID = subflownode.ManagerID;
				subflownodesymbol.FlowNodeValue = subflownode.FlowNodeValue;
				subflownodesymbol.FlowNodeIsInputNode = subflownode.FlowNodeIsInputNode;
				subflownodesymbol.RecSubFlowNodeCount = subflownode.RecSubFlowNodeCount;

				// Create the CustomOrthogonalLink to connect the employee symbol with it's subemployee symbol.
				// Specifying the South and North compass headings for the link end point headings ensures that 
				// links connecting nodes that are in the same level will have identical line segments.
//				LinkCmd linkcommand = new LinkCmd();
//				Link link = new Link(Link.Shapes.OrthogonalLine);
//				link.EndPoints.LastEndPointDecorator = new EndPointDecorator(EndPointVisuals.ClosedArrow);
//				link.EndPoints.LastEndPointDecorator.FillStyle.Color = Color.Black;
//				link.Labels.Add(new Syncfusion.Windows.Forms.Diagram.LinkLabel(link, iInputNumber.ToString()));
//
//				link.LineStyle.LineWidth=1;
//				link.Labels[0].BackgroundStyle.Color=Color.White;
//				link.Labels[0].FontStyle.Bold = true;
//				linkcommand.Link = link;	
		
				MyLink ortholink = new MyLink(subflownodesymbol.CenterPort.Location, CompassHeading.South, 
					subflownodesymbol.CenterPort.Location, CompassHeading.North);
				LinkCmd linkcommand = new LinkCmd();
//				ortholink.EndPoints.FirstEndPointDecorator = new EndPointDecorator(EndPointVisuals.Diamond);
				ortholink.EndPoints.LastEndPointDecorator = new EndPointDecorator(EndPointVisuals.ClosedArrow);
				ortholink.EndPoints.LastEndPointDecorator.FillStyle.Color = Color.Black;
				ortholink.Labels.Add(new Syncfusion.Windows.Forms.Diagram.LinkLabel(ortholink, iInputNumber.ToString()));
				ortholink.LineStyle.LineWidth = 1;
				ortholink.Labels[0].BackgroundStyle.Color = Color.White;
				ortholink.Labels[0].FontStyle.Bold = true;
				linkcommand.Link = ortholink;

				// Set up the source and target ports for the link
				if (subflownodesymbol.FlowNodeIsInputNode)
				{
					if (iInputNum % 2 == 0)
					{
						if (iInputNumber < iInputNum/2)
						{
							subflownodesymbol.X = flownodesymbol.X + flownodesymbol.Width/2 - 160*(iInputNum/2-iInputNumber) + 25;
							linkcommand.TargetPort = flownodesymbol.left_topports[iInputNumber];
						}
						else
						{
							subflownodesymbol.X = flownodesymbol.X + flownodesymbol.Width/2 + 160*(iInputNumber-iInputNum/2) + 25;
							linkcommand.TargetPort = flownodesymbol.right_topports[iInputNumber-iInputNum/2];
						}
						linkcommand.SourcePort = subflownodesymbol.CenterPort;
					}
					else
					{
						if (iInputNumber < (iInputNum-1)/2)
						{
							subflownodesymbol.X = flownodesymbol.X + flownodesymbol.Width/2 - 160*((iInputNum-1)/2-iInputNumber) - subflownodesymbol.Width/2;
							linkcommand.TargetPort = flownodesymbol.left_topports[iInputNumber];
						}
						else if (iInputNumber == (iInputNum-1)/2)
						{
							subflownodesymbol.X = flownodesymbol.X + flownodesymbol.Width/2 - subflownodesymbol.Width/2;
							linkcommand.TargetPort = flownodesymbol.topport;
						}
						else
						{
							subflownodesymbol.X = flownodesymbol.X + flownodesymbol.Width/2 + 160*(iInputNumber-(iInputNum-1)/2) - subflownodesymbol.Width/2;
							linkcommand.TargetPort = flownodesymbol.right_topports[iInputNumber-1-(iInputNum-1)/2];
						}
						linkcommand.SourcePort = subflownodesymbol.CenterPort;
					}
					subflownodesymbol.Y = (nLevelCount-subflownode.LevelCount) * 170 + 500;
					if (CheckIsHaveFlowNode(subflownodesymbol))
					{
						subflownodesymbol.Y = (nLevelCount-subflownode.LevelCount-1)*170 + 500;
						CalFlowNodeLevel(flownode);
					}
					iInputNumber++;
				}
				else
				{
					if (iOutputNum % 2 == 0)
					{
						if (iOutputNumber < iOutputNum/2)
						{
							subflownodesymbol.X = flownodesymbol.X + flownodesymbol.Width/2 - 160*(iOutputNum/2-iOutputNumber) + 25;
							linkcommand.SourcePort = flownodesymbol.left_bottomports[iOutputNumber];
						}
						else
						{
							subflownodesymbol.X = flownodesymbol.X + flownodesymbol.Width/2 + 160*(iOutputNumber-iOutputNum/2) + 25;
							linkcommand.SourcePort = flownodesymbol.right_bottomports[iOutputNumber-iOutputNum/2];
						}
						linkcommand.TargetPort =subflownodesymbol.CenterPort;
					}
					else
					{
						if (iOutputNumber < (iOutputNum-1)/2)
						{
							subflownodesymbol.X = flownodesymbol.X + flownodesymbol.Width/2 - 160*((iOutputNum-1)/2-iOutputNumber) - subflownodesymbol.Width/2;
							linkcommand.SourcePort = flownodesymbol.left_bottomports[iOutputNumber];
						}
						else if (iOutputNumber == (iOutputNum-1)/2)
						{
							subflownodesymbol.X = flownodesymbol.X + flownodesymbol.Width/2 - subflownodesymbol.Width/2;
							linkcommand.SourcePort = flownodesymbol.bottomport;
						}
						else
						{
							subflownodesymbol.X = flownodesymbol.X + flownodesymbol.Width/2 + 160*(iOutputNumber-(iOutputNum-1)/2) - subflownodesymbol.Width/2;
							linkcommand.SourcePort = flownodesymbol.right_bottomports[iOutputNumber-1-(iOutputNum-1)/2];
						}
						linkcommand.TargetPort =subflownodesymbol.CenterPort;
					}
					subflownodesymbol.Y = 630 + (nLevelCount-1+subflownode.LevelCount-2) * 170;
					if (CheckIsHaveFlowNode(subflownodesymbol))
					{
						subflownodesymbol.Y = 630 + (nLevelCount-1+subflownode.LevelCount-2+1)*170;
						CalFlowNodeLevel(flownode);
					}
					iOutputNumber++;
				}
				
				this.Diagram.Model.AppendChild(subflownodesymbol);			
				// Execute the command to connect the two symbols
				this.Diagram.Controller.ExecuteCommand(linkcommand);

				this.IterCreateFlowNodeSymbol(subflownode, subflownodesymbol, nLevelCount);
			}
		}

		// Iterative sub-flownode symbol node creation
		private void IterCreateFlowNodeSymbol(Ari_FlowNode flownode, Ari_ProcessSymbol flownodesymbol, int nLevelCount)
		{
			int iInputNumber = 0, iOutputNumber = 0;
			int iInputNum = CalNodeNumber(true, flownode, flownode.SubFlowNodes);
			int iOutputNum = CalNodeNumber(false, flownode, flownode.SubFlowNodes);
			foreach(Ari_FlowNode subflownode in flownode.SubFlowNodes)
			{
				// Create a FlowNodeSymbol for each of the sub-flownodes of the particular flownode
				Ari_FlowNodeSymbol subflownodesymbol = new Ari_FlowNodeSymbol(subflownode.SubFlowNodes.Count, subflownode.FlowNodeIsInputNode);
				subflownodesymbol.FlowNodeID = subflownode.FlowNodeID;
				subflownodesymbol.FlowNodeName = subflownode.FlowNodeName;
				subflownodesymbol.ManagerID = subflownode.ManagerID;
				subflownodesymbol.FlowNodeValue = subflownode.FlowNodeValue;
				subflownodesymbol.FlowNodeIsInputNode = subflownode.FlowNodeIsInputNode;
				subflownodesymbol.RecSubFlowNodeCount = subflownode.RecSubFlowNodeCount;

				// Create the CustomOrthogonalLink to connect the employee symbol with it's subemployee symbol.
				// Specifying the South and North compass headings for the link end point headings ensures that 
				// links connecting nodes that are in the same level will have identical line segments.
//				LinkCmd linkcommand = new LinkCmd();
//				Link link = new Link(Link.Shapes.OrthogonalLine);
//				link.EndPoints.LastEndPointDecorator = new EndPointDecorator(EndPointVisuals.ClosedArrow);
//				link.EndPoints.LastEndPointDecorator.FillStyle.Color = Color.Black;
//				link.Labels.Add(new Syncfusion.Windows.Forms.Diagram.LinkLabel(link, iInputNumber.ToString()));
//
//				link.LineStyle.LineWidth=1;
//				link.Labels[0].BackgroundStyle.Color=Color.White;
//				link.Labels[0].FontStyle.Bold = true;
//				linkcommand.Link = link;		
	
				LinkCmd linkcommand = new LinkCmd();

				// Set up the source and target ports for the link
				if (subflownodesymbol.FlowNodeIsInputNode)
				{
					if (iInputNum % 2 == 0)
					{
						if (iInputNumber < iInputNum/2)
						{
							subflownodesymbol.X = flownodesymbol.X + flownodesymbol.Width/2 - 250*(iInputNum/2-iInputNumber) + 25;
							linkcommand.TargetPort = flownodesymbol.left_topports[iInputNumber];
						}
						else
						{
							subflownodesymbol.X = flownodesymbol.X + flownodesymbol.Width/2 + 250*(iInputNumber-iInputNum/2) + 25;
							linkcommand.TargetPort = flownodesymbol.right_topports[iInputNumber-iInputNum/2];
						}
						linkcommand.SourcePort =subflownodesymbol.bottomport;
					}
					else
					{
						if (iInputNumber < (iInputNum-1)/2)
						{
							subflownodesymbol.X = flownodesymbol.X + flownodesymbol.Width/2 - 250*((iInputNum-1)/2-iInputNumber) - subflownodesymbol.Width/2;
							linkcommand.TargetPort = flownodesymbol.left_topports[iInputNumber];
						}
						else if (iInputNumber == (iInputNum-1)/2)
						{
							subflownodesymbol.X = flownodesymbol.X + flownodesymbol.Width/2 - subflownodesymbol.Width/2;
							linkcommand.TargetPort = flownodesymbol.topport;
						}
						else
						{
							subflownodesymbol.X = flownodesymbol.X + flownodesymbol.Width/2 + 250*(iInputNumber-(iInputNum-1)/2) - subflownodesymbol.Width/2;
							linkcommand.TargetPort = flownodesymbol.right_topports[iInputNumber-1-(iInputNum-1)/2];
						}
						linkcommand.SourcePort =subflownodesymbol.bottomport;
					}
					subflownodesymbol.Y = (nLevelCount-subflownode.LevelCount) * 170 + 500;
					iInputNumber++;
				}

				else
				{
					if (iOutputNum % 2 == 0)
					{
						if (iOutputNumber < iOutputNum/2)
						{
							subflownodesymbol.X = flownodesymbol.X + flownodesymbol.Width/2 - 250*(iOutputNum/2-iOutputNumber) + 25;
							linkcommand.SourcePort = flownodesymbol.left_bottomports[iOutputNumber];
						}
						else
						{
							subflownodesymbol.X = flownodesymbol.X + flownodesymbol.Width/2 + 250*(iOutputNumber-iOutputNum/2) + 25;
							linkcommand.SourcePort = flownodesymbol.right_bottomports[iOutputNumber-iOutputNum/2];
						}
						linkcommand.TargetPort =subflownodesymbol.topport;
					}
					else
					{
						if (iOutputNumber < (iOutputNum-1)/2)
						{
							subflownodesymbol.X = flownodesymbol.X + flownodesymbol.Width/2 - 250*((iOutputNum-1)/2-iOutputNumber) - subflownodesymbol.Width/2;
							linkcommand.SourcePort = flownodesymbol.left_bottomports[iOutputNumber];
						}
						else if (iOutputNumber == (iOutputNum-1)/2)
						{
							subflownodesymbol.X = flownodesymbol.X + flownodesymbol.Width/2 - subflownodesymbol.Width/2;
							linkcommand.SourcePort = flownodesymbol.bottomport;
						}
						else
						{
							subflownodesymbol.X = flownodesymbol.X + flownodesymbol.Width/2 + 250*(iOutputNumber-(iOutputNum-1)/2) - subflownodesymbol.Width/2;
							linkcommand.SourcePort = flownodesymbol.right_bottomports[iOutputNumber-1-(iOutputNum-1)/2];
						}
						linkcommand.TargetPort =subflownodesymbol.topport;
					}
					subflownodesymbol.Y = 600 + flownodesymbol.Height + (nLevelCount-1+subflownode.LevelCount-2) * 170;
					iOutputNumber++;
				}
				PointF point=new PointF(subflownodesymbol.CenterPort.Location.X,subflownodesymbol.CenterPort.Location.Y-70);
				MyLink ortholink = new MyLink(subflownodesymbol.CenterPort.Location, CompassHeading.South, 
					point, CompassHeading.North);
//				ortholink.EndPoints.FirstEndPointDecorator = new EndPointDecorator(EndPointVisuals.Diamond);
				ortholink.EndPoints.LastEndPointDecorator = new EndPointDecorator(EndPointVisuals.ClosedArrow);
				ortholink.EndPoints.LastEndPointDecorator.FillStyle.Color = Color.Black;
				ortholink.Labels.Add(new Syncfusion.Windows.Forms.Diagram.LinkLabel(ortholink, iInputNumber.ToString()));
				ortholink.LineStyle.LineWidth = 1;
				ortholink.Labels[0].BackgroundStyle.Color = Color.White;
				ortholink.Labels[0].FontStyle.Bold = true;
				linkcommand.Link = ortholink;
				
				this.Diagram.Model.AppendChild(subflownodesymbol);			
				// Execute the command to connect the two symbols
				this.Diagram.Controller.ExecuteCommand(linkcommand);

				this.IterCreateFlowNodeSymbol(subflownode, subflownodesymbol, nLevelCount);
			}
		}				

		/// <summary>
		/// ÿһΣҪȡݵĵԪڰȷӦߵĴϸ
		/// </summary>
		/// <returns></returns>
		private double GetUnitOfNewValues()
		{
			double sum = 0;
			foreach(DataColumn dc in this.dtValue.Columns)
			{
				sum = sum + Math.Abs(Convert.ToDouble(this.dtValue.Rows[this.dtValue.Rows.Count-1][dc.ColumnName]));
			}
			if(sum!=0)
				return 1/sum;
			else
				return double.NaN;
		}

		public void UpdateSankey()
		{
			double dd = GetUnitOfNewValues();
			foreach(INode node in this.Diagram.Model.Nodes)
			{
				string strName = node.Name;
				if(strName.IndexOf("Link") != -1)
				{
					Link link = (Link)node;
					Symbol sNode = (Symbol)link.FromNode;
					if (sNode.Name.IndexOf("Ari_FlowNodeSymbol") == -1)
						sNode = (Symbol)link.ToNode;
					Ari_FlowNodeSymbol curNode = (Ari_FlowNodeSymbol)sNode;
					double dNodeValue = Convert.ToDouble(this.dtValue.Rows[this.dtValue.Rows.Count-1][curNode.FlowNodeName]);
					link.Labels[0].Text = dNodeValue.ToString();
					link.LineStyle.LineWidth = Convert.ToInt16(dd*dNodeValue*120);
				}
			}
		}
	}
}
