using System;
using System.Drawing;
using System.Collections;
using System.Runtime.Serialization;

using Syncfusion.Windows.Forms.Diagram;

namespace SankeyTest
{
	/// <summary>
	/// Ari_FlowNodeSymbol ժҪ˵
	/// </summary>
	[Serializable]
	public class Ari_FlowNodeSymbol : Symbol, ISerializable
	{
		public CirclePort leftport;
		public CirclePort rightport;
		public CirclePort topport;
		public CirclePort bottomport;


		public CirclePort []left_topports;
		public CirclePort []right_topports;
		public CirclePort []left_bottomports;
		public CirclePort []right_bottomports;

		private RoundRect rect = null;
		private Label nameLbl = null;
		private Label titleLbl = null;
		private String strManagerID = String.Empty;
		private String strValue = String.Empty;
		private bool bIsInputNode = false;
		private int nRecSubFlowNodeCount = 0;

		public Ari_FlowNodeSymbol()
		{
			//
			// TODO: ڴ˴ӹ캯߼
			//
			this.rect = new RoundRect(0, 0, 150, 70);
			this.LineStyle.LineWidth = 1;
			this.rect.FillStyle.Type = Syncfusion.Windows.Forms.Diagram.FillStyleType.LinearGradient;
			this.rect.FillStyle.ForeColor =  System.Drawing.Color.Orange;
			this.rect.FillStyle.Color = System.Drawing.Color.OrangeRed;
			this.AppendChild(this.rect);
			this.titleLbl = this.AddLabel("", BoxPosition.Center);
			this.titleLbl.FontStyle.Name = "Verdana";
			this.titleLbl.FontStyle.Size = 7;
			this.titleLbl.FontStyle.Style = System.Drawing.FontStyle.Italic;
			this.titleLbl.OffsetY = -5;
			this.titleLbl.BackgroundStyle.Color = System.Drawing.Color.Transparent;
			this.titleLbl.FitBlackBox = true;
			this.titleLbl.WrapText = false;
			this.titleLbl.NoClip = false;
			this.titleLbl.ReadOnly = true;
			this.nameLbl = this.AddLabel("", BoxPosition.Center);
			this.nameLbl.OffsetY = 7;
			this.nameLbl.FontStyle.Name = "Verdana";
			this.nameLbl.FontStyle.Size = 8;
			this.nameLbl.FontStyle.Style = System.Drawing.FontStyle.Regular;
			this.nameLbl.BackgroundStyle.Color = System.Drawing.Color.Transparent;
			this.nameLbl.ReadOnly = true;
			this.nameLbl.FitBlackBox = true;
			this.nameLbl.WrapText = false;
			this.nameLbl.NoClip = false;
			
			leftport = new CirclePort(new PointF(0, this.Height / 2));
			rightport = new CirclePort(new PointF(this.Width, this.Height / 2));
			topport = new CirclePort(new PointF(this.Width / 2, 0));
			bottomport = new CirclePort(new PointF(this.Width / 2, this.Height));

			leftport.Visible=false;
			rightport.Visible=false;
			topport.Visible=false;
			bottomport.Visible=false;

			AppendChild(leftport);
			AppendChild(rightport);
			AppendChild(topport);
			AppendChild(bottomport);
		}

		public Ari_FlowNodeSymbol(int iSubNumber, bool bIsInput)
		{
			//
			// TODO: ڴ˴ӹ캯߼
			//
			this.rect = new RoundRect(0, 0, 150, 70);
			this.LineStyle.LineWidth = 1;
			this.rect.FillStyle.Type = Syncfusion.Windows.Forms.Diagram.FillStyleType.LinearGradient;
			this.rect.FillStyle.ForeColor =  System.Drawing.Color.Orange;
			this.rect.FillStyle.Color = System.Drawing.Color.OrangeRed;
			this.AppendChild(this.rect);
			this.titleLbl = this.AddLabel("", BoxPosition.Center);
			this.titleLbl.FontStyle.Name = "Verdana";
			this.titleLbl.FontStyle.Size = 7;
			this.titleLbl.FontStyle.Style = System.Drawing.FontStyle.Italic;
			this.titleLbl.OffsetY = -5;
			this.titleLbl.BackgroundStyle.Color = System.Drawing.Color.Transparent;
			this.titleLbl.FitBlackBox = true;
			this.titleLbl.WrapText = false;
			this.titleLbl.NoClip = false;
			this.titleLbl.ReadOnly = true;
			this.nameLbl = this.AddLabel("", BoxPosition.Center);
			this.nameLbl.OffsetY = 7;
			this.nameLbl.FontStyle.Name = "Verdana";
			this.nameLbl.FontStyle.Size = 8;
			this.nameLbl.FontStyle.Style = System.Drawing.FontStyle.Regular;
			this.nameLbl.BackgroundStyle.Color = System.Drawing.Color.Transparent;
			this.nameLbl.ReadOnly = true;
			this.nameLbl.FitBlackBox = true;
			this.nameLbl.WrapText = false;
			this.nameLbl.NoClip = false;
			
			leftport = new CirclePort(new PointF(0, this.Height / 2));
			rightport = new CirclePort(new PointF(this.Width, this.Height / 2));
			topport = new CirclePort(new PointF(this.Width / 2, 0));
			bottomport = new CirclePort(new PointF(this.Width / 2, this.Height));

			float fWidth = this.Width/iSubNumber-20;
			if (iSubNumber > 1 && bIsInput)
			{
				if (iSubNumber % 2 == 0)
				{
					left_topports = new CirclePort[iSubNumber/2];
					right_topports = new CirclePort[iSubNumber/2];
					for(int i=0; i<left_topports.Length; i++)
					{
						left_topports[i] = new CirclePort(new PointF(this.Width / 2-fWidth*(left_topports.Length-i), 0));
						left_topports[i].Visible = false;
						AppendChild(left_topports[i]);
						right_topports[i] = new CirclePort(new PointF(this.Width / 2+fWidth*(i+1), 0));
						right_topports[i].Visible = false;
						AppendChild(right_topports[i]);
					}
				}
				else
				{
					left_topports = new CirclePort[(iSubNumber-1)/2];
					right_topports = new CirclePort[(iSubNumber-1)/2];
					for(int i=0; i<left_topports.Length; i++)
					{
						left_topports[i] = new CirclePort(new PointF(this.Width / 2-fWidth*(left_topports.Length-i), 0));
						left_topports[i].Visible = false;
						AppendChild(left_topports[i]);
						right_topports[i] = new CirclePort(new PointF(this.Width / 2+fWidth*(i+1), 0));
						right_topports[i].Visible = false;
						AppendChild(right_topports[i]);
					}
				}
			}

			if (iSubNumber > 1 && !bIsInput)
			{
				if (iSubNumber % 2 == 0)
				{
					left_bottomports = new CirclePort[iSubNumber/2];
					right_bottomports = new CirclePort[iSubNumber/2];
					for(int i=0; i<left_bottomports.Length; i++)
					{
						left_bottomports[i] = new CirclePort(new PointF(this.Width / 2-fWidth*(left_bottomports.Length-i), this.Height));
						left_bottomports[i].Visible = false;
						AppendChild(left_bottomports[i]);
						right_bottomports[i] = new CirclePort(new PointF(this.Width / 2+fWidth*(i+1), this.Height));
						right_bottomports[i].Visible = false;
						AppendChild(right_bottomports[i]);
					}
				}
				else
				{
					left_bottomports = new CirclePort[(iSubNumber-1)/2];
					right_bottomports = new CirclePort[(iSubNumber-1)/2];
					for(int i=0; i<left_bottomports.Length; i++)
					{
						left_bottomports[i] = new CirclePort(new PointF(this.Width / 2-fWidth*(left_bottomports.Length-i), this.Height));
						left_bottomports[i].Visible = false;
						AppendChild(left_bottomports[i]);
						right_bottomports[i] = new CirclePort(new PointF(this.Width / 2+fWidth*(i+1), this.Height));
						right_bottomports[i].Visible = false;
						AppendChild(right_bottomports[i]);
					}
				}
			}

			leftport.Visible=false;
			rightport.Visible=false;
			topport.Visible=false;
			bottomport.Visible=false;

			AppendChild(leftport);
			AppendChild(rightport);
			AppendChild(topport);
			AppendChild(bottomport);
		}

		public Ari_FlowNodeSymbol(Ari_FlowNodeSymbol src) : base(src)
		{
		}

		// Serialization constructor
		protected Ari_FlowNodeSymbol(SerializationInfo info, StreamingContext context) : base(info, context)
		{
			this.strManagerID = info.GetString("ManagerID");
			this.strValue = info.GetString("Value");
			this.bIsInputNode = info.GetBoolean("IsInputNode");
			this.nRecSubFlowNodeCount = info.GetInt32("RecSubFlowNodeCount");
		}

		protected override void GetObjectData(SerializationInfo info, StreamingContext context)
		{
			base.GetObjectData(info, context);

			info.AddValue("ManagerID", this.strManagerID);
			info.AddValue("Value", this.strValue);
			info.AddValue("IsInputNode", this.bIsInputNode);
			info.AddValue("RecSubFlowNodeCount", this.nRecSubFlowNodeCount);
		}

		public string FlowNodeName
		{
			get
			{
				return this.nameLbl.Text;
			}
			set
			{
				this.nameLbl.Text = value;
				this.nameLbl.Size = this.nameLbl.SizeToText(this.Size);
			}
		}

		public string FlowNodeID
		{
			get
			{
				return this.titleLbl.Text;
			}
			set
			{
				this.titleLbl.Text = value;
				this.titleLbl.Size = this.titleLbl.SizeToText(this.Size);
			}
		}

		public string ManagerID
		{
			get { return this.strManagerID; }
			set
			{
				if(this.strManagerID != value)
					this.strManagerID = value;
			}
		}

		public string FlowNodeValue
		{
			get { return this.strValue; }
			set
			{
				if(this.strValue != value)
					this.strValue = value;
			}
		}

		public bool FlowNodeIsInputNode
		{
			get { return this.bIsInputNode; }
			set 
			{ 
				if(this.bIsInputNode != value)
					this.bIsInputNode = value; 
			}
		}
		
		public int RecSubFlowNodeCount
		{
			get { return this.nRecSubFlowNodeCount; }
			set 
			{
				if(this.nRecSubFlowNodeCount != value)
					this.nRecSubFlowNodeCount = value; 
			}
		}		
	}
}
