using System;
using System.Drawing;
using System.Runtime.Serialization;

using Syncfusion.Windows.Forms.Diagram;

namespace SankeyTest
{
	/// <summary>
	/// Ari_ProcessSymbol ժҪ˵
	/// </summary>
	[Serializable()]
	public class Ari_ProcessSymbol : Symbol, ISerializable
	{
		private Syncfusion.Windows.Forms.Diagram.Rectangle rect = null;
		private Label nameLbl = null;
		private Label titleLbl = null;

		public CirclePort leftport;
		public CirclePort rightport;
		public CirclePort topport;
		public CirclePort bottomport;

		public CirclePort []left_topports;
		public CirclePort []right_topports;
		public CirclePort []left_bottomports;
		public CirclePort []right_bottomports;

		public Ari_ProcessSymbol()
		{
			//
			// TODO: ڴ˴ӹ캯߼
			//
			this.rect = new Syncfusion.Windows.Forms.Diagram.Rectangle(0, 0, 150, 30);
			this.LineStyle.LineWidth = 1;
			this.rect.FillStyle.Type = Syncfusion.Windows.Forms.Diagram.FillStyleType.LinearGradient;
			this.rect.FillStyle.ForeColor =  System.Drawing.Color.Orange;
			this.rect.FillStyle.Color = System.Drawing.Color.OrangeRed;
			this.AppendChild(this.rect);
			this.titleLbl = this.AddLabel("", BoxPosition.Center);
			this.titleLbl.FontStyle.Name = "Verdana";
			this.titleLbl.FontStyle.Size = 7;
			this.titleLbl.FontStyle.Style = System.Drawing.FontStyle.Italic;
			this.titleLbl.OffsetY = 7;
			this.titleLbl.BackgroundStyle.Color = System.Drawing.Color.Transparent;
			this.titleLbl.FitBlackBox = true;
			this.titleLbl.WrapText = false;
			this.titleLbl.NoClip = false;
			this.titleLbl.ReadOnly = true;
			this.nameLbl = this.AddLabel("", BoxPosition.Center);
			this.nameLbl.OffsetY = -5;
			this.nameLbl.FontStyle.Name = "Verdana";
			this.nameLbl.FontStyle.Size = 8;
			this.nameLbl.FontStyle.Style = System.Drawing.FontStyle.Regular;
			this.nameLbl.BackgroundStyle.Color = System.Drawing.Color.Transparent;
			this.nameLbl.ReadOnly = true;
			this.nameLbl.FitBlackBox = true;
			this.nameLbl.WrapText = false;
			this.nameLbl.NoClip = false;
		}

		public Ari_ProcessSymbol(int iInputSubNumber, int iOutputSubNumber)
		{
			//////////////////////////////////////////////////////////////////
			// Add child nodes to the symbol programmatically
			//////////////////////////////////////////////////////////////////
			this.rect = new Syncfusion.Windows.Forms.Diagram.Rectangle(0, 0, 150, 30);
			this.LineStyle.LineWidth = 1;
			this.rect.FillStyle.Type = Syncfusion.Windows.Forms.Diagram.FillStyleType.LinearGradient;
			this.rect.FillStyle.ForeColor =  System.Drawing.Color.Orange;
			this.rect.FillStyle.Color = System.Drawing.Color.OrangeRed;
			this.AppendChild(this.rect);
			this.titleLbl = this.AddLabel("", BoxPosition.Center);
			this.titleLbl.FontStyle.Name = "Verdana";
			this.titleLbl.FontStyle.Size = 7;
			this.titleLbl.FontStyle.Style = System.Drawing.FontStyle.Italic;
			this.titleLbl.OffsetY = -5;
			this.titleLbl.BackgroundStyle.Color = System.Drawing.Color.Transparent;
			this.titleLbl.FitBlackBox = true;
			this.titleLbl.WrapText = false;
			this.titleLbl.NoClip = false;
			this.titleLbl.ReadOnly = true;
			this.nameLbl = this.AddLabel("", BoxPosition.Center);
			this.nameLbl.OffsetY = 7;
			this.nameLbl.FontStyle.Name = "Verdana";
			this.nameLbl.FontStyle.Size = 8;
			this.nameLbl.FontStyle.Style = System.Drawing.FontStyle.Regular;
			this.nameLbl.BackgroundStyle.Color = System.Drawing.Color.Transparent;
			this.nameLbl.ReadOnly = true;
			this.nameLbl.FitBlackBox = true;
			this.nameLbl.WrapText = false;
			this.nameLbl.NoClip = false;

			if (iInputSubNumber < iOutputSubNumber)
				rect.Width = (iOutputSubNumber) * 250;
			else
				rect.Width = (iInputSubNumber) * 250;
			rect.Height = 30;

			leftport = new CirclePort(new PointF(0, this.Height / 2));
			rightport = new CirclePort(new PointF(this.Width, this.Height / 2));
			topport = new CirclePort(new PointF(this.Width / 2, 0));
			bottomport = new CirclePort(new PointF(this.Width / 2, this.Height));

			if (iInputSubNumber > 1)
			{
				if (iInputSubNumber % 2 == 0)
				{
					left_topports = new CirclePort[iInputSubNumber/2];
					right_topports = new CirclePort[iInputSubNumber/2];
					for(int i=0; i<left_topports.Length; i++)
					{
						left_topports[i] = new CirclePort(new PointF(this.Width / 2-250*(left_topports.Length-i)+100, 0));
						left_topports[i].Visible = false;
						AppendChild(left_topports[i]);
						right_topports[i] = new CirclePort(new PointF(this.Width / 2+250*i+100, 0));
						right_topports[i].Visible = false;
						AppendChild(right_topports[i]);
					}
				}
				else
				{
					left_topports = new CirclePort[(iInputSubNumber-1)/2];
					right_topports = new CirclePort[(iInputSubNumber-1)/2];
					for(int i=0; i<left_topports.Length; i++)
					{
						left_topports[i] = new CirclePort(new PointF(this.Width / 2-250*(left_topports.Length-i)+100, 0));
						left_topports[i].Visible = false;
						AppendChild(left_topports[i]);
						right_topports[i] = new CirclePort(new PointF(this.Width / 2+250*i+100, 0));
						right_topports[i].Visible = false;
						AppendChild(right_topports[i]);
					}
				}
			}

			if (iOutputSubNumber > 1)
			{
				if (iOutputSubNumber % 2 == 0)
				{
					left_bottomports = new CirclePort[iOutputSubNumber/2];
					right_bottomports = new CirclePort[iOutputSubNumber/2];
					for(int i=0; i<left_bottomports.Length; i++)
					{
						left_bottomports[i] = new CirclePort(new PointF(this.Width / 2-250*(left_bottomports.Length-i)+100, this.Height));
						left_bottomports[i].Visible = false;
						AppendChild(left_bottomports[i]);
						right_bottomports[i] = new CirclePort(new PointF(this.Width / 2+250*i+100, this.Height));
						right_bottomports[i].Visible = false;
						AppendChild(right_bottomports[i]);
					}
				}
				else
				{
					left_bottomports = new CirclePort[(iOutputSubNumber-1)/2];
					right_bottomports = new CirclePort[(iOutputSubNumber-1)/2];
					for(int i=0; i<left_bottomports.Length; i++)
					{
						left_bottomports[i] = new CirclePort(new PointF(this.Width / 2-250*(left_bottomports.Length-i)+100, this.Height));
						left_bottomports[i].Visible = false;
						AppendChild(left_bottomports[i]);
						right_bottomports[i] = new CirclePort(new PointF(this.Width / 2+250*i+100, this.Height));
						right_bottomports[i].Visible = false;
						AppendChild(right_bottomports[i]);
					}
				}
			}

			leftport.Visible=false;
			rightport.Visible=false;
			topport.Visible=false;
			bottomport.Visible=false;
		
			AppendChild(leftport);
			AppendChild(rightport);
			AppendChild(topport);
			AppendChild(bottomport);
		}

		public string FlowNodeName
		{
			get
			{
				return this.nameLbl.Text;
			}
			set
			{
				this.nameLbl.Text = value;
				this.nameLbl.Size = this.nameLbl.SizeToText(this.Size);
			}
		}

		public string FlowNodeID
		{
			get
			{
				return this.titleLbl.Text;
			}
			set
			{
				this.titleLbl.Text = value;
				this.titleLbl.Size = this.titleLbl.SizeToText(this.Size);
			}
		}

		/// <summary>
		/// Serialization constructor for symbols.
		/// </summary>
		/// <param name="info">Serialization state information</param>
		/// <param name="context">Streaming context information</param>
		protected Ari_ProcessSymbol(SerializationInfo info, StreamingContext context) : base(info, context)
		{
		}		

		/// <summary>
		/// Populates a SerializationInfo with the data needed to
		/// serialize the target object.
		/// </summary>
		/// <param name="info">SerializationInfo object to populate</param>
		/// <param name="context">Destination streaming context</param>
		protected override void GetObjectData(SerializationInfo info, StreamingContext context)
		{
			base.GetObjectData(info, context);
		}

		/// <summary>
		/// Called when deserialization is complete.
		/// </summary>
		/// <param name="sender">Object performing the deserialization</param>
		protected override void OnDeserialization(object sender)
		{
			base.OnDeserialization(sender);
		}
	}
}
