using System;
//using System.Collections.Generic;
using System.Text;

using System.Collections;
using System.Drawing;

using Syncfusion.Windows.Forms.Diagram;

namespace SankeyTest
{
    class MyLinkSupport
    {
     
        public MyLinkSupport()
		{
			
		}

    public CompassHeading[] CalculateCompassHeadings(Port sourcePort, Port targetPort)
		{
			
			Port[] ports = new Port[2] ;
			ports[0] = sourcePort;
			ports[1]= targetPort;

			CompassHeading[] compassHeadings= new CompassHeading[2];
			compassHeadings[0] = CalculateCompassHeading(ports[0]);
			compassHeadings[1] = CalculateCompassHeading(ports[1]);
			
			return compassHeadings;
		}

		public CompassHeading CalculateCompassHeading(Port targetPort)
		{
			
			Port port = targetPort as Port;

			CompassHeading compassHeading= new CompassHeading();
			compassHeading = CompassHeading.None;
			
			switch(port.Name)
			{
						
				case "TopPort" :
					compassHeading = CompassHeading.North;
					break;
				case "BottomPort":
					compassHeading = CompassHeading.South; 									
					break;
				case "LeftPort":
					compassHeading = CompassHeading.West;
					break;
				case "RightPort":
					compassHeading = CompassHeading.East;
					break;
			}
			return compassHeading;
		}

       

        public bool CheckForDuplicateConnections(Ari_FlowNodeSymbol sourceNode, Ari_FlowNodeSymbol targetNode)
		{
			

			if(sourceNode == targetNode)
			{
				return false;
			}

			if((sourceNode.Edges.Count > 0) && (targetNode.Edges.Count > 0))
			{
				IEnumerator sourceEdgeEnumerator = sourceNode.Edges.GetEnumerator(); 
				IEnumerator targetEdgeEnumerator = targetNode.Edges.GetEnumerator(); 
					
				while(sourceEdgeEnumerator.MoveNext())
				{	
					targetEdgeEnumerator.Reset();
					while(targetEdgeEnumerator.MoveNext())
					{
						if(sourceEdgeEnumerator.Current == targetEdgeEnumerator.Current)
						{
							return false;
						}
					}
						
				}
				return true;
			}
			else
			{
				return true;
			}
		}
	}
}


